# html.pl of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
package html;

use strict;

require 'cookie.lib';
html::GetCompressedCookies($html::cookie_name);

sub BEGIN(){
	no strict "refs";
	$html::http_printed = 0;
	$html::html_printed = 0;
	$html::no_foot = 0;
	%html::charset = (
		'sjis' => 'Shift_JIS',
		'jis' => 'ISO-2022-JP',
		'euc' => 'EUC-JP'
		);
	@html::bottom_link = (['./', 'gbv֖߂']);
	$SIG{__WARN__} = \&warn_handler;
	$SIG{__DIE__} = \&warn_handler;
	unless (grep{ $_ eq $html::code}('euc', 'jis', 'sjis')) {
		$html::code = 'euc';
		 warn 'Undefined $html::code.' ;
	}
	grep {
		warn("Undefined \$$_.") unless ${$_};
	} ('html::cookie_name', 'html::mail', 'html::admin', 'html::body');
}
	
sub http_head($){
	die('Double http head.') if $html::http_printed;
	print "Content-type: text/html\n";
	#print qq|Contnet-type: text/html Charset: $html::charset{$html::code}\n|;
	if ($_[0]) {
		$html::Cookies{'myname'} = $main::FORM{'myname'};
		$html::Cookies{'mail'} = $main::FORM{'mail'};
		html::SetCookieExpDate(make_cookie_date(time + 60*24*60*60));
		html::SetCompressedCookies($html::cookie_name, %html::Cookies);
	}
	print "\n";
	$html::http_printed = 1;
}

sub html_head($){
	die('Double html head.') if $html::html_printed;
	print qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML LANG="ja">
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=$html::charset{$html::code}">
<LINK REV="made" HREF="$html::mail">
<TITLE>$_[0]</TITLE>
</HEAD>
$html::body
|;
	$html::html_printed = 1;
}

sub make_cookie_date($){
	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime($_[0]);
	$wday = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$wday],
	$year += 1900;
	$mon = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$mon];
	sprintf("$wday, %02d-$mon-$year %02d:%02d:%02d GMT", $mday, $hour, $min, $sec);
}

sub claim(@) {
	@html::claim = (@html::claim, @_);
}

sub warn_handler {
	@html::warning = (@html::warning, @_);
}


sub END(){
	unless ($html::http_printed) { http_head(0); }
	unless ($html::html_printed)	 {
		warn 'No contents.';
		html_head('Script error.');
	}
	if (@html::claim) {
		print qq|<H1>eG[.</H1>\n<UL>\n|;
		grep {print  "<LI>$_"} @html::claim;
		print qq|</UL>\n|;
	}
	if (@html::warning) {
		print qq|<H1>Script error(s).</H1>\n<UL>\n|;
		grep {print  "<LI>$_"} @html::warning;
		print qq|</UL>\n|;
	}
	unless($html::no_foot) {
		print "<HR>\n";
		grep { print qq|<DIV><A HREF="$_->[0]">$_->[1]</A></DIV>\n| } @html::bottom_link;
	}
	print qq|</BODY>\n</HTML>\n|;
}
1;