# w-k.pl of 3dai relayed novel version 2.11.
# Copyright (C) 2000-2002 Izui Masakazu & Ito Akihiro.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
use strict;

require 'sub.pl';
require 'bunkiinfo2.pl';
require 'input.pl';

sub w_k() {
	pre();
	modify();
	check(\%main::FORM);
	check2(\%main::FORM, get_p_data());
}

sub pre() {
	if ($main::ksn_len >= $main::ksn_max) {
		die qq|̊͂łɏI܂B<BR>\n炭̂ڂ肪Ƃ܂B|;
	}
	@main::pass = (substr($main::FORM{'bunki'}, 0, 2), split //, substr($main::FORM{'bunki'}, 2));
	$main::pass = join '', @main::pass;
}

sub modify() {
	no strict "vars";
	if ($pass[0] == $ksn_len) { #OK
	} elsif ($pass[0] > $ksn_len) { #O
		die '򌳂̏񂪕słB';
	} elsif ($pass[0] + scalar @pass - 1 < $ksn_len) { #ӂ͓ebڂɂȂ̂;~悤Ȃ
		die "̏ꏊ͓eł܂B<BR>\n
̓̕eɂ菬̍\ω\܂B";
	} else {
		#򂪂܂Ă邩ɊmF
		opendir BUNKI, "$data_dir";
		while ($pass[0] != $ksn_len) {
			my @bunki_files;
			#t@CłĂ炾
			if (@bunki_files =  grep /^bnk$pass[0]$pass[1]$pass[2]\.txt$/, readdir BUNKI) {
				die "̏ꏊ͓eł܂B<BR>\n
̓̕eɂ菬̍\ω\܂B";
			}
			#␳
			$pass[0] = sprintf ("%02d", 1 + shift @pass);
		}
		closedir BUNKI;
	
		#␳2
		$FORM{'bunki'} = $pass = join '', @pass;
	}
}

sub check($) {
	my @bunkiarray = info::bunkiarray($main::pass);
	$main::new_bunki = 0;
	grep { $main::new_bunki = $_ if $_ > $main::new_bunki; } @bunkiarray;
	$main::new_bunki++;
	if ($main::new_bunki > 5) {
		die '̏ꏊ͂ȏ㕪ł܂B';
	}
	if (length $_[0]->{'article'} < 40) {
		html::claim('{Z܂B');
	}
	unless ($_[0]->{'myname'}) {
		html::claim('yl[͂ĂB');
	}
	if ( !$_[0]->{'odai1'} or !$_[0]->{'odai2'} or !$_[0]->{'odai3'}) {
		html::claim('(3Ƃ)͂ĂB');
	}
	if (odai_KO($_[0]->{'odai1'}, $_[0]->{'odai2'}, $_[0]->{'odai3'})){
	        html::claim('肪ٗlɎʂĂ܂B');
	}
}

sub get_p_data(){
	(scalar @main::pass == 1) ?
	make_hash("$main::data_dir/ksn$main::pass.txt") :
	make_hash("$main::data_dir/bnk$main::pass.txt");
}

sub check2($$) {
	my ($F, $p) = @_[0,1];
	@main::temp = ($F->{'article'}, $F->{'comment'});
	$F->{'comment'} =~ s/\n/<BR>/g;

	$F->{'article'} = adjust_article(
		$F->{'article'},
		$F->{'pdai1'} = $p->{'odai1'},
		$F->{'pdai2'} = $p->{'odai2'},
		$F->{'pdai3'} = $p->{'odai3'}
	);
	#Ae̋֎~
	if ($F->{'myname'} eq $p->{'myname'}) {
		html::claim('̏ɑēe邱Ƃ͂ł܂B');
	}
	#de̋֎~
	my $i;
	for ($i = 1; $i <= 5; $i++) {
		if ($F->{'myname'} eq $p->{"name$i"}){
			html::claim('ꏊQ񓊍e邱Ƃ͂ł܂B');
		}
	}
	$F->{'date'} = sprintf("%08x", time);
	$F->{'host'} = $ENV{'REMOTE_ADDR'};
	if ($main::ksn_len + scalar @main::pass == 1) {
		$F->{'pdai1'} = $F->{'pdai2'} = $F->{'pdai3'} = '';
	}
}

sub adjust_article($$$$){
	my ($var, @odai) = @_;
	#--蕔Ԃ
	unless ($mian::ksn_len + scalar @main::pass == 1) {
		if ($main::FORM{'option'} =~ /^([1-3])([1-3])([1-3])$/) {
			my %temp = ($odai[$1 - 1] => 1, $odai[$2 - 1] => 2, $odai[$3 - 1] => 3);
			@odai = sort {$temp{$a} <=> $temp{$b}} @odai;
		}
		grep{
			if ($var =~ /\Q$_\E/) {
				$var = "$`\x01$_\x02$'";
			} else {
				html::claim("u$_vgĂ܂");
			}
		} @odai;
		$var =~ s/\x01/<ODAI>/g;
		$var =~ s/\x02/<\/ODAI>/g;
	}
	#--i
	@_ = split /\n+-{5,}\n+/, "\n$var\n";
	grep{
		study $_;
		#--ƐK̉s͏
		s/^\n*//;
		s/\n*$//;
		my @lines = split /\n/, $_;
		my $line;
		foreach $line (@lines) {
			if ($line eq '') {
				$line = "</P><P>";
			} elsif ($line =~ /^u(.+)v$/) {
				$line = "</P><DIV>u$1v</DIV><P>";
			} else {
				$line .= '<BR>';
			}
		}
		$_ = join '', @lines;
		$_ = "<P>$_</P>";
		#--Qȏ̔pXy[X͔pXy[X
		s/  +/ /g;
	} @_;
	if( scalar(@_) %2 == 0 ){ push( @_,"" ); }
	$var = join( "<BLOCKQUOTE>", @_ );
	$var =~ s/<BLOCKQUOTE>(.*?)<BLOCKQUOTE>/<BLOCKQUOTE>$1<\/BLOCKQUOTE>/g;
	$var =~ s/<BR><\/P>/<\/P>/g;
	$var =~ s/<P><\/P>//g;
#	$var =~ s/>/>\n/g; #--DEBUGp
	$var;
}

sub odai_KO(@){
	my ($var);
	while ($var = shift @_) {
		grep{
			if ($_ =~ /\Q$var\E/ or $var =~ /\Q$_\E/ ) { return 1; }
		} @_;
	}
	0;
}

1;
